<?php
/**
 * Perforce Swarm
 *
 * @copyright   2013-2019 Perforce Software. All rights reserved.
 * @license     Please see LICENSE.txt in top-level readme folder of this distribution.
 * @version     2019.1/1829459
 */

return array(
    'queue'  => array(
        'workers'                     => 3,
        'worker_lifetime'             => 595,     // 10 minutes (less 5s)
        'worker_task_timeout'         => 1800,    // 30 minutes (max execution time per task)
        'worker_memory_limit'         => '1G',
        'disable_trigger_diagnostics' => true,
        'worker_change_save_delay'    => 5000,    // millisecond delay for a future changesaved task in the queue
    ),
    'router' => array(
        'routes' => array(
            'worker' => array(
                'type' => 'Zend\Router\Http\Segment',
                'options' => array(
                    'route'    => '/queue/worker[/]',
                    'defaults' => array(
                        'controller' => Queue\Controller\IndexController::class,
                        'action'     => 'worker',
                    ),
                ),
            ),
            'status' => array(
                'type' => 'Zend\Router\Http\Segment',
                'options' => array(
                    'route'    => '/queue/status[/]',
                    'defaults' => array(
                        'controller' => Queue\Controller\IndexController::class,
                        'action'     => 'status',
                    ),
                ),
            ),
            'tasks' => array(
                'type' => 'Zend\Router\Http\Segment',
                'options' => array(
                    'route'    => '/queue/tasks[/]',
                    'defaults' => array(
                        'controller' => Queue\Controller\IndexController::class,
                        'action'     => 'tasks',
                    ),
                ),
            ),
        ),
    ),
    'xhprof' => array(
        'ignored_routes' => array('worker')
    ),
    'security' => array(
        'login_exempt' => array('worker')
    ),
    'controllers' => array(
        'factories' => [
            Queue\Controller\IndexController::class => Application\Controller\IndexControllerFactory::class
        ],
    ),
    'service_manager' => array(
        'factories' => array(
            'queue' => function ($services) {
                return new Queue\Manager($services);
            },
        ),
    ),
);
